# frozen_string_literal: true

require 'forwardable'
require 'action_push/version'
require 'action_push/errors'

module ActionPush
  autoload :Base, 'action_push/base'
  autoload :Envelope, 'action_push/envelope'
  autoload :Util, 'action_push/util'

  module Concerns
    autoload :ClassMethodDelivery, 'action_push/concerns/class_method_delivery'
    autoload :RegisterDefault, 'action_push/concerns/register_default'
    autoload :RegisterDeliveryMethod, 'action_push/concerns/register_delivery_method'
    autoload :RegisterInterceptor, 'action_push/concerns/register_interceptor'
  end

  module Delivery
    autoload :Explosion, 'action_push/delivery/explosion'
    autoload :Gorush, 'action_push/delivery/gorush'
    autoload :Memory, 'action_push/delivery/memory'
  end

  module Provider
    autoload :Base, 'action_push/provider/base'
    autoload :Test, 'action_push/provider/test'
  end

  module Ios
    autoload :Message, 'action_push/ios/message'
    autoload :Alert, 'action_push/ios/alert'
  end
end
