# frozen_string_literal: true

module ActionPush
  # envelope = ActionPush::Envelope.new(title: 'Alert', body: 'You ave 2 messages')
  # envelope.add(:ios, ActionPush::Ios::Message.new)
  #
  # envelope.for(:ios) do |ios|
  #   ios.sound = 'wow.mp3'
  # end
  class Envelope
    attr_accessor :title
    attr_accessor :body
    attr_accessor :payload

    def initialize(params = {})
      params.each { |name, value| public_send("#{name}=", value) }

      yield(self) if block_given?
    end

    def add(provider, push)
      pushes[provider] = push
    end

    def for(provider)
      push = pushes.fetch(provider) do
        raise ArgumentError, "provider with name <#{provider}> was not registered"
      end

      block_given? ? yield(push) : push
    end

    alias_method :[], :for

    def pushes
      @pushes ||= {}
    end
  end
end
